"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_BACKGROUND_COLOR = '#9b9b9b';

/**
 * @class UIDashedBox
 */

var UIDashedBox = function (_React$Component) {
  _inherits(UIDashedBox, _React$Component);

  /**
   * @constructor
   */

  function UIDashedBox(props) {
    _classCallCheck(this, UIDashedBox);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(UIDashedBox).call(this, props));

    _this.state = {
      color: DEFAULT_BACKGROUND_COLOR
    };
    return _this;
  }

  /**
   * @event onMouseOver
   */


  _createClass(UIDashedBox, [{
    key: 'onMouseOver',
    value: function onMouseOver() {
      this.setState({
        color: '#666666'
      });
    }

    /**
     * @event onMouseLeave
     */

  }, {
    key: 'onMouseLeave',
    value: function onMouseLeave() {
      this.setState({
        color: DEFAULT_BACKGROUND_COLOR
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var containerStyl = Object.assign({
        height: this.props.height,
        width: this.props.width,
        color: this.state.color,
        borderColor: this.state.color
      }, UIDashedBox.styles.container);
      var contentsStyl = Object.assign({
        marginTop: this.props.height / 2 - 14
      }, UIDashedBox.styles.contents);
      return _react2.default.createElement(
        'div',
        { style: containerStyl,
          onClick: this.props.onClick,
          onMouseOver: this.onMouseOver.bind(this),
          onMouseLeave: this.onMouseLeave.bind(this) },
        _react2.default.createElement(
          'p',
          { style: contentsStyl },
          this.props.text
        )
      );
    }
  }]);

  return UIDashedBox;
}(_react2.default.Component);

UIDashedBox.propTypes = {
  /**
   * @property {String} className - the class name of the container element
   */
  className: _react2.default.PropTypes.string,

  /**
   * @property {Number} height - the box height
   */
  height: _react2.default.PropTypes.number,

  /**
   * @property {Number} width - the box width
   */
  width: _react2.default.PropTypes.number,

  /**
   * @property {Function} onClick - the onClick function
   */
  onClick: _react2.default.PropTypes.func,

  /**
   * @property {String} text - the text
   * @required
   */
  text: _react2.default.PropTypes.string.isRequired
};
UIDashedBox.styles = {
  container: {
    border: '1px dashed ' + DEFAULT_BACKGROUND_COLOR,
    textAlign: 'center',
    borderRadius: '5px',
    boxSizing: 'border-box',
    fontSize: '14px',
    transition: 'all .2s ease-in-out'
  },
  contents: {
    transition: 'all .2s ease-in-out'
  }
};
exports.default = UIDashedBox;